Kea: isc::yang::TranslatorPdPool Class Reference

| Kea 3.0.0

isc::yang::TranslatorPdPool Class Reference

Prefix delegation pool translation between YANG and JSON. More...

`#include <translator_pd_pool.h>`

Inheritance diagram for isc::yang::TranslatorPdPool:
[legend]

## Public Member Functions
| TranslatorPdPool (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorPdPool ()=default
| Destructor.
isc::data::ElementPtr | getPdPool (libyang::DataNode const &data_node)
| Translate a pd-pool from YANG to JSON.
isc::data::ElementPtr | getPdPoolFromAbsoluteXpath (std::string const &xpath)
| Translate a pd-pool from YANG to JSON.
void | setPdPool (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set pd-pool from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorOptionDataList
| TranslatorOptionDataList (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionDataList ()=default
| Destructor.
isc::data::ConstElementPtr | getOptionDataList (libyang::DataNode const &data_node)
| Translate option data list from YANG to JSON.
isc::data::ConstElementPtr | getOptionDataListFromAbsoluteXpath (std::string const &xpath)
| Translate option data list from YANG to JSON.
void | setOptionDataList (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data list from JSON to YANG.
Public Member Functions inherited from isc::yang::TranslatorOptionData
| TranslatorOptionData (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~TranslatorOptionData ()=default
| Destructor.
isc::data::ElementPtr | getOptionData (libyang::DataNode const &data_node)
| Translate an option data from YANG to JSON.
isc::data::ElementPtr | getOptionDataFromAbsoluteXpath (std::string const &xpath)
| Translate an option data from YANG to JSON.
void | setOptionData (const std::string &xpath, isc::data::ConstElementPtr elem)
| Translate and set option data from JSON to YANG.
Public Member Functions inherited from isc::yang::Translator
| Translator (sysrepo::Session session, const std::string &model)
| Constructor.
virtual | ~Translator ()=default
| Destructor.
template<typename T>
void | checkAndGet (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {xpath} key.
void | checkAndGetAndJsonifyLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, const std::string &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node, converts it from string to JSON and stores it in the specified storage.
template<typename T>
void | checkAndGetDiverging (isc::data::ElementPtr const &storage, libyang::DataNode const &data_node, std::string const &key, std::string const &xpath, T translate) const
| Calls {translate} for the element found at {xpath} relative to {data_node} and sets the result in {storage} with the {key} key.
void | checkAndGetDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndGetLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
void | checkAndSetDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndSetLeafList (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath as a leaf-list.
void | checkAndSetUserContext (isc::data::ConstElementPtr const &from, std::string const &xpath)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | checkAndStringifyAndSetLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | deleteItem (const std::string &xpath)
| Delete basic value from YANG.
libyang::DataNode | findXPath (std::string const &xpath) const
| Retrieves a YANG data node by xpath.
template<typename functor_t>
void | forAll (std::string const &xpath, functor_t f) const
| Run a function for a node and all its children.
std::optional< libyang::DataNode > | getData (std::string const &xpath) const
| Get a YANG data node found at the given absolute xpath.
isc::data::ElementPtr | getItem (libyang::DataNode const &data_node, std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given xpath that is relative to the given source node.
isc::data::ElementPtr | getItemFromAbsoluteXpath (std::string const &xpath) const
| Translate a basic value from YANG to JSON for a given absolute xpath.
template<typename T>
isc::data::ElementPtr | getList (libyang::DataNode const &data_node, std::string const &xpath, T &t, isc::data::ElementPtr(T::*f)(libyang::DataNode const &)) const
| Retrieve a list as ElementPtr from sysrepo from a certain xpath.
void | getMandatoryDivergingLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name, std::string const &yang_name) const
| Retrieves a child YANG data node identified by one name from the given parent YANG container node and stores it in the specified storage under a different name.
void | getMandatoryLeaf (isc::data::ElementPtr &storage, libyang::DataNode const &data_node, std::string const &name) const
| Retrieves a child YANG data node identified by name from the given parent YANG container node and stores it in the specified storage.
bool | schemaNodeExists (std::string const &xpath) const
| Checks whether a YANG node exists in the schema.
void | setItem (const std::string &xpath, isc::data::ConstElementPtr const elem, libyang::LeafBaseType const type)
| Translate and set basic value from JSON to YANG.
void | setMandatoryDivergingLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, std::string const &yang_name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.
void | setMandatoryLeaf (isc::data::ConstElementPtr const &from, std::string const &xpath, std::string const &name, libyang::LeafBaseType const type)
| Get an element from given ElementPtr node and set it in sysrepo at given xpath.

## Protected Member Functions
isc::data::ElementPtr | getPdPoolIetf6 (libyang::DataNode const &data_node)
| getPdPool for ietf-dhcpv6-server.
isc::data::ElementPtr | getPdPoolKea (libyang::DataNode const &data_node)
| getPdPool for kea-dhcp6-server.
void | setPdPoolIetf6 (const std::string &xpath, isc::data::ConstElementPtr elem)
| setPdPool for ietf-dhcpv6-server.
void | setPdPoolKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setPdPool for kea-dhcp6-server.
Protected Member Functions inherited from isc::yang::TranslatorOptionDataList
isc::data::ConstElementPtr | getOptionDataListKea (libyang::DataNode const &data_node)
| getOptionDataList for kea-dhcp[46].
void | setOptionDataListKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionDataList for kea-dhcp[46].
Protected Member Functions inherited from isc::yang::TranslatorOptionData
isc::data::ElementPtr | getOptionDataKea (libyang::DataNode const &data_node)
| getOptionData JSON for kea-dhcp[46].
void | setOptionDataKea (const std::string &xpath, isc::data::ConstElementPtr elem)
| setOptionData for kea-dhcp[46].

## Additional Inherited Members
Static Public Member Functions inherited from isc::yang::Translator
static isc::data::ElementPtr | translateFromYang (std::optional< libyang::DataNode > data_node)
| Translate basic value from the given YANG data node to JSON element.
static std::optional< std::string > | translateToYang (isc::data::ConstElementPtr const &elem, libyang::LeafBaseType const type)
| Translate basic value from JSON to YANG.
Protected Types inherited from isc::yang::Translator
using | Deserializer
| Maps YANG types to functions that transform a YANG type into an ElementPtr.
using | Serializer
| Maps YANG types to functions that transform the string representation of an Element into a string that can be passed into Session::setItem().
Static Protected Member Functions inherited from isc::yang::Translator
static std::string | decode64 (std::string const &input)
| Decode a YANG element of binary type to a string that can be stored in an Element::string JSON.
static std::string | encode64 (std::string const &input)
| Encode a string such that it can be stored in a YANG element of binary type.
static Deserializer | initializeDeserializer ()
| Initializes the deserializer which is used to translate a YANG node to an ElementPtr.
static Serializer | initializeSerializer ()
| Initializes the serializer which is used to translate the string value of an Element to a string that can be passed into Session::setItem().
Protected Attributes inherited from isc::yang::Translator
std::string | model_
| The model.
sysrepo::Session | session_
| The sysrepo session.

## Detailed Description

Prefix delegation pool translation between YANG and JSON.

JSON syntax for kea-dhcp6-server is:

{
"prefix": <prefix base>,
"prefix-len": <prefix length>,
"delegated-len": <delegated length>,
"excluded-prefix": <excluded prefix>,
"excluded-prefix-len": <excluded prefix length>,
"option-data": [ <list of option data> ],
"client-class": "<guard class name>",
"client-classes": [ <list of guard class names> ],
"require-client-classes": [ <list of required class names> ],
"evaluate-additional-classes": [ <list of evaluate additional class names> ],
"user-context": { <json map> },
"comment": "<comment>"
}
isc::data
Definition base_stamped_element.cc:12

YANG syntax for ietf-dhcpv6-server is with pool-id as the key.

+--rw pool-id uint32
+--rw prefix inet:ipv6-prefix
+--rw prefix-length uint8
+--rw valid-lifetime yang:timeticks
+--rw renew-time yang:timeticks
+--rw rebind-time yang:timeticks
+--rw preferred-lifetime yang:timeticks
+--rw rapid-commit? boolean
+--rw client-class? string
+--rw client-classes* string
+--rw max-pd-space-utilization? threshold
+--rw option-set-id?
/server/server-config/option-sets/option-set/option-set-id
isc::config
Definition command_interpreter.cc:23
isc::yang
Definition adaptor.cc:17

YANG syntax for kea-dhcp6-server is with prefix as the key.

+--rw pd-pool* [prefix]
+--rw prefix inet:ipv6-prefix
+--rw delegated-len? uint8
+--rw option-data* [code space]
+--rw client-class? string
+--rw client-classes* string
+--rw require-client-classes* string
+--rw evaluate-additional-classes* string
+--rw excluded-prefix? inet:ipv6-prefix
+--rw user-context? user-context

An example in JSON and YANG formats:

[
{
"prefix": "2001:db8:0:1000::",
"prefix-len": 56,
"delegated-len": 64
}
]
/ietf-dhcpv6-server:server (container)
/ietf-dhcpv6-server:server/server-config (container)
/ietf-dhcpv6-server:server/server-config/network-ranges (container)
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111'] (list instance)
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111']/network-range-id = 111
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111']/network-prefix = 2001:db8::/48
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111']/pd-pools (container)
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111']/pd-pools/
pd-pool[pool-id='0'] (list instance)
/ietf-dhcpv6-server:server/server-config/network-ranges/
pd-pool[pool-id='0']/pool-id = 0
network-range[network-range-id='111']/pd-pools/
pd-pool[pool-id='0']/prefix = 2001:db8:0:1000::/56
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111']/pd-pools/
pd-pool[pool-id='0']/prefix-length = 56
/ietf-dhcpv6-server:server/server-config/network-ranges
network-range[network-range-id='111']/pd-pools/
pd-pool[pool-id='0']/max-pd-space-utilization = disabled
/kea-dhcp6-server:config (container)
/kea-dhcp6-server:config/subnet6[id='111'] (list instance)
/kea-dhcp6-server:config/subnet6[id='111']/id = 111
/kea-dhcp6-server:config/subnet6[id='111']/subnet = 2001:db8::/48
/kea-dhcp6-server:config/subnet6[id='111']/
pd-pool[prefix='2001:db8:0:1000::/56' (list instance)
/kea-dhcp6-server:config/subnet6[id='111']/
pd-pool[prefix='2001:db8:0:1000::/56'/prefix = 2001:db8:0:1000::/56
/kea-dhcp6-server:config/subnet6[id='111']/
pd-pool[prefix='2001:db8:0:1000::/56'/delegated-len = 64

A translator class for converting a pd-pool between YANG and JSON.

Currently supported models:

- kea-dhcp6-server
- ietf-dhcpv6-server (partial support)

Definition at line 121 of file translator_pd_pool.h.

## Constructor & Destructor Documentation

## ◆ TranslatorPdPool()

isc::yang::TranslatorPdPool::TranslatorPdPool | ( | sysrepo::Session | session,
|  | const std::string & | model )

Constructor.

Parameters

  session | Sysrepo session.
  model | Model name.

Definition at line 24 of file translator_pd_pool.cc.

References isc::yang::TranslatorOptionDataList::TranslatorOptionDataList().

Referenced by isc::yang::TranslatorPdPools::TranslatorPdPools().

Here is the call graph for this function:

## ◆ ~TranslatorPdPool()

virtual isc::yang::TranslatorPdPool::~TranslatorPdPool | ( |  | ) |
| virtualdefault

Destructor.

## Member Function Documentation

## ◆ getPdPool()

ElementPtr isc::yang::TranslatorPdPool::getPdPool | ( | libyang::DataNode const & | data_node | ) |

Translate a pd-pool from YANG to JSON.

Parameters

  data_node | the YANG node representing the PD pool

Returns
  the JSON representation of the PD pool

Exceptions

  BadValue | on pd-pool without well formed prefix.
  NetconfError | when sysrepo raises an error.

Definition at line 31 of file translator_pd_pool.cc.

References getPdPoolIetf6(), getPdPoolKea(), isc_throw, isc::yang::Translator::model_, and isc::Exception::what().

Referenced by getPdPoolFromAbsoluteXpath(), and isc::yang::TranslatorPdPools::getPdPoolsCommon().

Here is the call graph for this function:

## ◆ getPdPoolFromAbsoluteXpath()

ElementPtr isc::yang::TranslatorPdPool::getPdPoolFromAbsoluteXpath | ( | std::string const & | xpath | ) |

Translate a pd-pool from YANG to JSON.

Parameters

  xpath | The xpath of the pd-pool.

Returns
  JSON representation of the pd-pool.

Exceptions

  BadValue | on pd-pool without well formed prefix.
  NetconfError | when sysrepo raises an error.

Definition at line 48 of file translator_pd_pool.cc.

References isc::yang::Translator::findXPath(), and getPdPool().

Here is the call graph for this function:

## ◆ getPdPoolIetf6()

ElementPtr isc::yang::TranslatorPdPool::getPdPoolIetf6 | ( | libyang::DataNode const & | data_node | ) |
| protected

getPdPool for ietf-dhcpv6-server.

Parameters

  data_node | the YANG node representing the PD pool

Returns
  JSON representation of the pd-pool.

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 57 of file translator_pd_pool.cc.

References isc::yang::Translator::checkAndGetDivergingLeaf(), isc::yang::Translator::checkAndGetLeaf(), Element::create(), Element::createMap(), isc::yang::Translator::getItem(), isc::yang::Translator::getMandatoryDivergingLeaf(), and isc_throw.

Referenced by getPdPool().

Here is the call graph for this function:

## ◆ getPdPoolKea()

ElementPtr isc::yang::TranslatorPdPool::getPdPoolKea | ( | libyang::DataNode const & | data_node | ) |
| protected

getPdPool for kea-dhcp6-server.

Parameters

  data_node | the YANG node representing the PD pool

Returns
  JSON representation of the pd-pool.

Exceptions

  NetconfError | when sysrepo raises an error.

Definition at line 96 of file translator_pd_pool.cc.

References isc::yang::Translator::checkAndGetAndJsonifyLeaf(), isc::yang::Translator::checkAndGetLeaf(), Element::create(), Element::createMap(), isc::yang::Translator::getItem(), isc::yang::TranslatorOptionDataList::getOptionDataList(), and isc_throw.

Referenced by getPdPool().

Here is the call graph for this function:

## ◆ setPdPool()

void isc::yang::TranslatorPdPool::setPdPool | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )

Translate and set pd-pool from JSON to YANG.

Parameters

  xpath | The xpath of the pd-pool.
  elem | The JSON element.

Definition at line 182 of file translator_pd_pool.cc.

References isc_throw, isc::yang::Translator::model_, setPdPoolIetf6(), setPdPoolKea(), and isc::Exception::what().

Referenced by isc::yang::TranslatorPdPools::setPdPoolsId(), and isc::yang::TranslatorPdPools::setPdPoolsPrefix().

Here is the call graph for this function:

## ◆ setPdPoolIetf6()

void isc::yang::TranslatorPdPool::setPdPoolIetf6 | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setPdPool for ietf-dhcpv6-server.

Parameters

  xpath | The xpath of the pd-pool.
  elem | The JSON element.

Exceptions

  BadValue | on pd-pool without prefix or prefix length.

Definition at line 200 of file translator_pd_pool.cc.

References isc::yang::Translator::checkAndSetDivergingLeaf(), isc::yang::Translator::checkAndSetLeaf(), Element::create(), isc_throw, and isc::yang::Translator::setItem().

Referenced by setPdPool().

Here is the call graph for this function:

## ◆ setPdPoolKea()

void isc::yang::TranslatorPdPool::setPdPoolKea | ( | const std::string & | xpath,
|  | isc::data::ConstElementPtr | elem )
| protected

setPdPool for kea-dhcp6-server.

Parameters

  xpath | The xpath of the pd-pool.
  elem | The JSON element.

Definition at line 229 of file translator_pd_pool.cc.

References isc::yang::Translator::checkAndSetLeaf(), isc::yang::Translator::checkAndSetLeafList(), isc::yang::Translator::checkAndSetUserContext(), Element::create(), isc::yang::Translator::setItem(), and isc::yang::TranslatorOptionDataList::setOptionDataList().

Referenced by setPdPool().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- translator_pd_pool.h
- translator_pd_pool.cc